package helper_methods;

/*
 * Improved version of code which has a helper method. 
 */
public class PointImproved { 
	private double x; 
	private double y;
	
	/*
	 * Helper method to calculate the distance.
	 */
	private double getDistanceFrom(PointImproved other) {
		double dist = 
				Math.sqrt(
					Math.pow(this.x - other.getX(), 2) + Math.pow(this.y - other.getY(), 2)
				);
		return dist;
	}

	public PointImproved(double x, double y) {
		this.x = x;
		this.y = y;
	}

	public void moveUp(double units) { 
		this.y += units; 
	}

	public double getX() {
		return this.x;
	}

	public double getY() {
		return this.y;
	}

	public double getDistanceFromOrigin() {
		return this.getDistanceFrom(new PointImproved(0, 0));
	}

	public double getDistancesTo(PointImproved p1, PointImproved p2) {
		return 
				this.getDistanceFrom(p1)
				+
				this.getDistanceFrom(p2); 
	}
	
	/*
	 * Exercise: replace the following three repetitions by the helper method calls.
	 * Then, create the same JUnit test to make sure that this improved version is correct.
	 * 
	 */
	public double getTriDistances(PointImproved p1, PointImproved p2) {
		return 
				Math.sqrt(Math.pow(this.x - p1.x, 2) + Math.pow(this.y - p1.y, 2))
				+
				Math.sqrt(Math.pow(this.x - p2.x, 2) + Math.pow(this.y - p2.y, 2))
				+
				Math.sqrt(Math.pow(p1.x - p2.x, 2) + Math.pow(p1.y - p2.y, 2));
	} 
}
